!!ARBfp1.0

#standard lighting with normal mapping and per pixel attenuation
#Author: Rich Whitehouse
#---------------------------------------------------------------------

#this has become somewhat of a mess.
#texture0 is the decal
#texture1 is the normal map, with dynamic shadow coords in .texcoord
#texture2 is the dynamic shadow texture, with light vectors in .texcoord
#texture3 is the 2d attenuation texture

PARAM	mulf = {2.0, 2.0, 2.0};
PARAM	subf = {-1.0, -1.0, -1.0};
PARAM	lightColor = program.env[1];
PARAM	invLightFar = program.env[2];

OUTPUT	out = result.color;
TEMP	nrml, dcal, attn, temp, dshd, atc;

#fetch the textures
TEX	dcal, fragment.texcoord[0], texture[0], 2D;
TEX	nrml, fragment.texcoord[0], texture[1], 2D;
TXP	dshd, fragment.texcoord[1], texture[2], 2D;
TXP	attn, fragment.texcoord[3], texture[3], 2D;

#derive the attenuation from w
MUL	atc.w, fragment.texcoord[3].w, invLightFar.x;
SGE	atc.z, atc.w, 0.0;
MUL	atc.w, atc.w, atc.w; #exponential falloff
SUB	atc.w, atc.z, atc.w;

MUL	attn, attn, atc.w;

#expand the normal
MAD	nrml, nrml, mulf, subf;
#re-normalize interpolated normal
DP3	temp, nrml, nrml;
RSQ	temp, temp.x;
MUL	nrml, nrml, temp;

#re-normalize interpolated light vector
DP3	temp, fragment.texcoord[2], fragment.texcoord[2];
RSQ	temp, temp.x;
MUL	temp, temp.x, fragment.texcoord[2];

DP3	temp, nrml, temp;

MUL	temp, temp, lightColor; #factor in light color

#apply minimum light level
MAX	temp, lightColor.w, temp;

MUL	temp, dcal, temp; #factor in decal
MUL	temp, fragment.color, temp; #factor in ambient color
MUL	temp, attn, temp; #factor in attenuation
SUB	dshd, 1.0, dshd;
MUL	temp, dshd, temp; #factor in dynamic shadows

MOV	temp.a, dcal.a; #set alpha component by decal

MOV	out, temp;

END
